<?php require '../doctype.php'?>
<html>
   <script src='../scripts/jquery.min.js'></script>
   <body>
      <div id='static-status'></div>
      <div id='dynamic-1-status'></div>
      <div id='dynamic-2-status'></div>
      <div id='dynamic-3-status'></div>
      <br>
      <video id='static-video' width="640" height="360" onplay='test_event_attributes()' muted>
         <source src="bunny.mp4?test=0" type="video/mp4">
         <source src="bunny.ogv?test=0" type="video/ogg">
         <source src="bunny.webm?test=0" type="video/webm">
      </video>
      <video id='static-video-2' width="64" height="36" onplay='test_event_attributes()' muted>
         <source src="bunny.mp4?test=1" type="video/mp4">
         <source src="bunny.ogv?test=1" type="video/ogg">
         <source src="bunny.webm?test=1" type="video/webm">
      </video>
      <br>
      <script>
         // Test dynamic capability checking and adding of video element.
         var type_to_use = null,
             tests_to_run;

         function append_text(txt) {
            var br = document.createElement('br');
            document.body.appendChild(br);
            document.body.appendChild(document.createTextNode(txt));
         }

         function assert(condition) {
            if (!condition) {
               throw "Assertion failed";
            }
         }

         function test_video(v, test_id) {
            var test_timeupdate = false,
               test_play = false,
               test_pause = false,
               test_ended = false,
               test_seeked = false,
               test_volumechange = false,
               test_canplay = false,
               test_playing = false,
               test_loadstart = false,
               test_progress = false;

            assert(v instanceof HTMLMediaElement);
            assert(v instanceof HTMLVideoElement);

            v.addEventListener('timeupdate', function () {
               $("#" + test_id + "-status").html(v.currentTime + " " + v.played.length);
               if (test_timeupdate) return;
               append_text('got timeupdate event for ' + test_id);
               test_timeupdate = true;
               v.pause(); // Fire pause event.
               v.muted = true; // Fire volume change.
               v.play();
            }, false);

            v.addEventListener('canplay', function () {
               if (test_canplay) return;
               append_text('got canplay event for ' + test_id);
               test_canplay = true;
               v.play();
            }, false);

            v.addEventListener('play', function () {
               if (test_play) return;
               append_text('got play event for ' + test_id);
               test_play = true;
            }, false);

            v.addEventListener('playing', function () {
               if (test_playing) return;
               append_text('got playing event for ' + test_id);
               test_playing = true;
               // Fire the seeked event, and skip ahead so that the test
               // finishes quickly.
               setTimeout(function() {
                  v.currentTime = 59;
                  v.play();
               }, 1000);
            }, false);

            v.addEventListener('loadstart', function () {
               if (test_loadstart) return;
               console.log('currentSrc=' + v.currentSrc);
               append_text('got loadstart event for ' + test_id);
               test_loadstart = true;
            }, false);

            v.addEventListener('progress', function () {
               if (test_progress) return;
               append_text('got progress event for ' + test_id);
               test_progress = true;
            }, false);

            v.addEventListener('pause', function () {
               if (test_pause) return;
               append_text('got pause event for ' + test_id);
               test_pause = true;
            }, false);

            v.addEventListener('ended', function () {
               if (test_ended) return;
               append_text('got ended event for ' + test_id);
               test_ended = true;
               append_text("Test " + test_id + " is a success");
               if(v.parentNode){
                   v.parentNode.removeChild(v);
               }
               next_test = tests_to_run.shift();
               if (next_test) {
                 next_test();
               }
            }, false);

            v.addEventListener('seeked', function () {
               if (test_seeked) return;
               append_text('got seek event for ' + test_id);
               test_seeked = true;
            }, false);

            v.addEventListener('volumechange', function () {
               if (test_volumechange) return;
               append_text('got volumechange event for ' + test_id);
               test_volumechange = true;
            }, false);
         }

         function test_static_video_element() {
            var v = $('#static-video')[0];
            test_video(v, 'static');
         }

         function test_dynamic_video_element_1() {
            var v = document.createElement('video');
            v.muted = true;
            v.controls = true;
            v.width = "640";
            v.height = "360";
            var source = document.createElement('source');
            source.src = type_to_use[0];
            source.type = type_to_use[1];
            v.appendChild(source);
            document.body.appendChild(v);
            test_video(v, 'dynamic-1');
         }

         function test_dynamic_video_element_2() {
            setTimeout(function() {
               var v = document.createElement('video');
               v.muted = true;
               v.width = "640";
               v.height = "360";
               v.src = type_to_use[0];
               v.type = type_to_use[1];
               v.controls = true;
               document.body.appendChild(v);
               test_video(v, 'dynamic-2');
            }, 10);
         }

         function test_dynamic_video_element_3() {
            setTimeout(function() {
               var v = document.createElement('video');
               v.muted = true;
               v.width = "640";
               v.height = "360";
               // Send a list instead of a string to test media
               // proxy url handling.
               v.src = [type_to_use[0]];
               v.type = type_to_use[1];
               v.controls = true;
               document.body.appendChild(v);
               test_video(v, 'dynamic-3');
            }, 10);
         }

         function test_capturing_event_listeners() {
            // TODO: Use a capturing event listener on the window object
            // catch events for static elements.
         }

         function test_event_attributes() {
            // onplay, etc.
            append_text("test_event_attributes: success");

         }

         function test_fullscreen_api() {
            // video.webkitEnterFullscreen
            // webkit[begin,end]fullscreen events
         }

         function test_mutation_ordering() {
            // Do property accesses see the latest values as set by
            // setAttribute calls?
            var video = $("#static-video")[0];
            try {
               var name = 'controls';
               var old_val = video.getAttribute(name);
               var new_val = true;
               video.setAttribute(name, new_val);
               append_text(name + "=" + video[name]);
               assert(video[name] == new_val);
            } catch (ex) {
               if (ex == "Assertion failed") {
                  append_text("test_mutation_ordering: failure");
               } else {
                  throw ex;
               }
               return;
            }
            append_text("test_mutation_ordering: success");
         }

         function test_attrs_that_may_not_be_implemented() {
            // Depending on the patch-level, IE's HTML5 video implementation
            // may not support some of these attributes.
            var video = $("#static-video-2")[0];
            video.setAttribute('loop', 'True');
            video.loop = false;
            video.setAttribute('prefetch', 'false');
            video.setAttribute('unsupported', 'false');
            // Can't do this on IE if the video is not loaded yet.
            try {
               video.currentTime = 59;
            } catch (ex) {
              append_text('Failed to set current time: ' + ex);
            }
            video.play();
            append_text('loop is ' + video.getAttribute('loop'));
            video.pause();
            // Unload the video.
            video.src = '';
            video.load();
         }

         function is_supported() {
            // Only try mp4. Our backend support for ogg is not very good somehow.
            // MP4 is supported by all the browsers we support.
            var types = {
               'video/mp4; codecs="avc1.42001E, mp4a.40.2"':
               [ "bunny.mp4", "video/mp4" ] };

            var v = document.createElement('video');
            if (v.canPlayType) {
               append_text("video element supported");
               for (var key in types) {
                  var res = v.canPlayType(key);
                  append_text("key=" + key + "res=" + res);
                  if (res === "probably" || res === "maybe") {
                     type_to_use = types[key];
                     append_text("using codec " + key);
                     break;
                  }
               }
               if (!type_to_use) {
                  append_text("codecs unsupported");
                  return false;
               }
               return true;
            } else {
               append_text("video element unsupported");
               return false;
            }
         }

         if (is_supported()) {
            test_mutation_ordering();
            test_attrs_that_may_not_be_implemented();
            test_static_video_element();
            tests_to_run = [test_dynamic_video_element_1,
                            test_dynamic_video_element_2,
                            test_dynamic_video_element_3];
         }
      </script>
   </body>
</html>
